package ActiveState::Config::Tokenizer::Buffer;

use strict;
use base qw(ActiveState::Config::Tokenizer);

sub new {
    my ($cls, $buffer) = @_;
    my $o = bless { buf => $buffer, line => 0 }, ref($cls) || $cls;
    $o->{lines} = [split /^/, $buffer];
    chomp @{$o->{lines}};
    $o;
}

sub savebuf {
    my $o = shift;
    if (@_) {
	$o->{savebuf} = shift;
    }
    defined $o->{savebuf} ? $o->{savebuf} : '';
}

sub readline {
    my $o = shift;
    my $line = $o->{line}++;
    $o->{lines}[$line];
}

sub lineno {
    my $o = shift;
    $o->{line};
}

sub filename { "<memory>" }
sub dir {
    use Cwd qw(cwd);
    cwd();
}

1;
